#pragma once

/* Copyright (C) 2014-2016 Achim Turan, Achim.Turan@o2online.de
 * https://github.com/AchimTuran/asplib
 *
 * This file is part of asplib (Achim's Signal Processing LIBrary)
 *
 * asplib (Achim's Signal Processing LIBrary) is free software:
 * you can redistribute it and/or modify it under the terms of the
 * GNU General Public License as published by the Free Software Foundation,
 * either version 3 of the License, or (at your option) any later version.
 *
 * asplib (Achim's Signal Processing LIBrary) is distributed
 * in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with asplib (Achim's Signal Processing LIBrary).
 * ifnot, see <http://www.gnu.org/licenses/>.
 *
 */



#include "Core/os/asplib_os.h"
#include "Core/Constants_Typedefs/asplib_Typedefs.h"

#include "Core/Constants_Typedefs/asplib_DataFmtDefines.hpp"
#include "Core/AutoFactory/asplib_TAutoFactory.hpp"

#include "Resampling/Interfaces/asplib_IResampling.hpp"


#define CREATE_ASPLIB_RESAMPLING_CLASS(Class, ClassID, InFmt, OutFmt, ResamplingObject)       \
class Class :                                                                                 \
  public TResamplingFactory::TRegisterProduct<Class, ClassID, InFmt, OutFmt>,                 \
  public ResamplingObject                                                                     \
{                                                                                             \
public:                                                                                       \
  Class() {}                                                                                  \
};

#define ASPLIB_FACTORY_RESAMPLING asplib::CResamplingFactory()


namespace asplib
{
class CResamplingFactoryMetaData
{
public:
  const static std::string Name;
};


typedef enum ResamplingID_t
{
  ASPLIB_RESAMPLING_INVALID_ID = -1,

  ASPLIB_RESAMPLING_Decimator,

  ASPLIB_RESAMPLING_MAX_ID
}ResamplingID_t;


typedef TAutoFactory<IResampling, ResamplingID_t, asplibFmt_t, CResamplingFactoryMetaData> TResamplingFactory;

class CResamplingFactory : public TResamplingFactory
{
public:
  CResamplingFactory();
  ~CResamplingFactory();
};
}


